;**** watchdog pro PC - pripojeny na COM **** verze WDT3 - cervenec 2004
; ma autovypinani s pomoci VHD90 zapojeny na tlacitkovy vstup
;
; prikazy:
; wdt83s     .... nastavi periodu watchdogu na 83 sekund
; wdt120s    .... nastavi periodu watchdogu na 120 sekund
; wdtpor900s .... jen ulozi tuto periodu do FLASH a po kazdem
;                 resetu/zapnuti PC nacte tuto periodu z FLASH
;		  (do teto doby 900sekund od zapnuti PC musi PC
;		   provest prikaz wdt120s nebo prikaz wdt....s s jinym casem)
;***************************************************************************

.include "tn12def.inc"

.def    hod_ok_rx    =r0
.def    delic125x    =r1
.def    tlmko        =r2
.equ    prodleva_tlacitka = $0e ; t.j. zakmity max. 120ms
.def    load_off1    =r3
.def    citac_off1   =r4
.def    mko_rx       =r5
.equ    ok_rx = $07
.def    citac_resetu =r6 
.def    stav         =r7 ; pro blikani mimo provoz
.def    hod0      =r8
.def    hod1      =r9
.def    zhasne    =r10
.def    sviti     =r11
.def    load1     =r12
.def    load10    =r13
.def    load100   =r14
.def    load1000  =r15
.def    xflags    =r16
.equ    xkprijimej   = 1
.equ    xkdin        = 2
.equ    xkresetuj    = 4
.equ    xkdata       = 8
.equ    xk_w         = $10
.equ    xk_d         = $20
.equ    xk_t         = $40
.equ    xk_vypnul_pc = $80
.equ    xprijimej   = 0
.equ    xdin        = 1
.equ    xresetuj    = 2
.equ    xdata       = 3
.equ    x_w         = 4
.equ    x_d         = 5
.equ    x_t         = 6
.equ    x_vypnul_pc = 7
.def    xcitacbitu=r17
.def    pom       =r18
.def    delic3    =r19
.def    wdt1000   =r20 ; citac sekund pro wdt
.def    wdt100    =r21
.def    wdt10     =r22
.def    wdt1      =r23
.def    val1000   =r24
.def    val100    =r25
.def    val10     =r26
.def    val1      =r27
.def    tlcitac   =r28
.def    delic125y =r29
.def    rxdata    =r30
.def    xpor      =r31
.equ    por_p      =0
.equ    por_o      =1
.equ    por_r      =2
.equ    por_eewr0  =3
.equ    por_eewr1  =4
.equ    kpor_p     =1
.equ    kpor_o     =2
.equ    kpor_r     =4
.equ    kpor_eewr0 =8
.equ    kpor_eewr1 =$10

.equ    ledka = 5
.equ    rele = 2
.equ    tlacitko = 1
.equ    rxd = 0

; registry jen v modu vypnuteho pocitace - casovani 2 sec
.def status_tlacitka = r19
.def citac1 = r20
.def citac2 = r21
.def citac3 = r22

;***** Code

.org 0
	ldi pom,$a0
	out acsr,pom ; vypne komparator
        rjmp pokracuj
.org 3
interrupt:  ; pro Xtal=4MHz je preruseni 15625 x za sekundu
        wdr
        sbrs xflags,xprijimej
        rjmp cekej_na_start
	dec delic3
	brne wdtdelic
	ldi delic3,$03
        sbrs xflags,xdata
        rjmp test_startbitu
        cpi xcitacbitu,$08
        breq test_stopbitu
        inc xcitacbitu
        sec
        sbic pinb,rxd
        clc
	sbis pinb,rxd
	mov mko_rx,hod_ok_rx
        ror rxdata
        cpi xcitacbitu,$02
        breq dej_deleni4
        cpi xcitacbitu,$05
        breq dej_deleni4
        rjmp wdtdelic

test_startbitu:
        sbis pinb,rxd
        rjmp neni_startbit
        sbr xflags,xkdata
        rjmp wdtdelic

test_stopbitu:
        sbis pinb,rxd
        rjmp jest_stopbit
	andi xflags,$86
        ori  xflags,$02
        rjmp wdtdelic

do_konec_int:
	cp delic125x,zhasne ; $04
	breq tl_vstup
	ldi pom,$7c
	cp delic125x,pom    ; $7C
	brne e_int
	cbi portb,tlacitko
	sbi ddrb,tlacitko
e_int:
	reti

tl_vstup:
	sbi portb,tlacitko
	cpi val1000,$2D
	brne xtlin
	cpi val100,$4B
	brne xtlin
	cpi val10,$56
	breq xtlin
	inc val1
	brne xtlin
	inc val10
xtlin:
	cbi ddrb,tlacitko
	reti

dej_deleni4:
        ldi delic3,$04
; -------------------------------------------------------------- 15625 x za sec
wdtdelic:
        dec delic125x
        brne do_konec_int
	ldi pom,$7d
        mov delic125x,pom
        dec delic125y
        brne sec_blikani
        ldi delic125y,$7d
        ; kazdou sekundu
	out ddrb,zhasne
	sbrc xpor,por_eewr0
	rjmp zapisuj_ee
        sbrc xflags,xresetuj
        rjmp byl_reset
        sbrc xflags,x_vypnul_pc
        rjmp konec_nahozeni
        dec wdt1
        brne konec_int
        ldi wdt1,$0a
        dec wdt10
        brne konec_int
        ldi wdt10,$0a
        dec wdt100
        brne konec_int
        ldi wdt100,$0a
        dec wdt1000
        brne konec_int
proved_reset:
        ldi xflags,$06
	; tonda
        cbi portb,rele ; log.0 do BC557 -> sepne rele -> resetuj PC
        ldi wdt1,$08   ; po 8 sec uvolni
konec_int:
        reti

sec_blikani: ; 124 x za sekundu
	sbic pinb,tlacitko
	rjmp neni_stisknuto_tl
	tst tlmko
	brne jiz_stlaceno
	ldi tlcitac,$00
jiz_stlaceno:
	ldi pom,prodleva_tlacitka
	mov tlmko,pom
neni_stisknuto_tl:
	tst tlmko
	breq tlmko_je_0
	dec tlmko
	sbrc tlcitac,7
	rjmp neni_tl
	inc tlcitac
	cpi tlcitac,$73
	brmi neni_tl
	ldi tlcitac,$81
	rjmp proved_reset

tlmko_je_0:
	tst tlcitac
	breq neni_tl
	cpi tlcitac,$5f
	brpl nuluj_tlcitac
	sbis eecr,eewe
	sbrc xpor,por_eewr0
	rjmp neni_tl
	eor stav,hod1
	ldi pom,$02
	out eear,pom
	out eedr,stav
	sbi eecr,eemwe
	sbi eecr,eewe
nuluj_tlcitac:
	clr tlcitac
neni_tl:
	cpi delic125y,$0c
	brne konec_int
	sbrs xflags,x_vypnul_pc
	sbis pinb,rxd
	mov mko_rx,hod_ok_rx
	cp stav,hod1
	brne bez_kontroly
	out ddrb,sviti
	dec mko_rx
	brne konec_int
	inc hod_ok_rx
	mov mko_rx,hod_ok_rx
	sbrs hod_ok_rx,3
	rjmp znovu_zapni_pc
	out ddrb,zhasne
wdtset2s:
	ldi pom,$06
	mov load_off1,pom
	mov citac_off1,pom
	cpi val1000,$2D
	brne err_poff
	cpi val100,$4B
	brne err_poff
	cpi val10,$57
	brmi ok_poff
err_poff:
	ldi val1,$10
	ldi val10,$56
	cp stav,hod1
	breq hlr
	ldi val10,$01
hlr:
	ldi val100,$4B
	ldi val1000,$2D
	rjmp wdt2s

ok_poff:
	cp stav,hod1
	breq hlav
	cpi val10,$02
	brmi hlav
	ldi val10,$01
	ldi val1,$10
hlav:
	rjmp wdt2s

bez_kontroly:
	dec mko_rx
	brne lo_int
	rjmp wdtset2s

ostatni:
	sbrs xflags,x_t
	rjmp inic_por
	cpi rxdata,$70   ; p
	breq je_p
	cpi rxdata,$6f   ; o
	breq je_o
	cpi rxdata,$72   ; r
	breq je_r
inic_por:
	andi xflags,$86
	ori  xflags,$02
	ldi  xpor,$00
	rjmp wdtdelic

je_p:
	sbrc xpor,por_p
	rjmp inic_por
	sbr  xpor,kpor_p
	rjmp wdtdelic

je_o:
	sbrc xpor,por_p
	sbrc xpor,por_o
	rjmp inic_por
	sbr  xpor,kpor_o
	rjmp wdtdelic

je_r:
	sbrc xpor,por_o
	sbrc xpor,por_r
	rjmp inic_por
	sbr  xpor,kpor_r
	rjmp wdtdelic

nastav_wdtpor:
	mov load1000,val1000
	mov load100,val100
	mov load10,val10
	mov load1,val1
	ldi xpor,$08 ; pro zapis do eeprom
	ldi delic125y,$1e
	andi xflags,$86
	ori  xflags,$02
	rjmp wdtdelic

zapisuj_ee:
	sbic eecr,eewe
lo_int:
	reti
	sbrc xpor,por_eewr1
	rjmp next_byte
	out eear,hod0
        out eecr,hod1
	mov  pom,load10
	swap pom
	or   pom,load1
        in xpor,eedr
        cp xpor,pom
        breq nezap0
	out eedr,pom
	sbi eecr,eemwe
	sbi eecr,eewe
nezap0:
	ldi delic125y,$1c
        ldi xpor,$18
	reti

next_byte:
	out eear,hod1
        out eecr,hod1
	out ddrb,sviti
	mov  pom,load1000
	swap pom
	or   pom,load100
        in xpor,eedr
        cp xpor,pom
        breq nezap1
	out eedr,pom
	sbi eecr,eemwe
	sbi eecr,eewe
nezap1:
	ldi delic125y,$1e
	ldi xpor,$00
	reti

; -----------------------------------------------------

byl_reset:
	mov mko_rx,hod_ok_rx
        dec wdt1
        brne konec2
        sbrc xflags,x_vypnul_pc
        rjmp zapni_pc
        sbr xflags,xk_vypnul_pc
        ldi wdt1,$05 ; po 5 sekundach zapni pc
        sbi portb,rele ; uvolni reset
	reti

konec2:
	cpi wdt1,$01
	breq konec3
	sbrs xflags,x_vypnul_pc
	sbis pinb,rxd
	rjmp konec3
	ldi wdt1,$02
konec3:
        reti

znovu_zapni_pc:
	sbr xflags,xk_vypnul_pc
zapni_pc:
	sbis pinb,rxd
	rjmp jiz_nahozeno
        cbr xflags,xkresetuj
        ldi wdt1,$04
        cbi portb,rele ; zapni pc
        reti

konec_nahozeni:
	mov mko_rx,hod_ok_rx
        dec wdt1
        brne konec4
jiz_nahozeno:
        ldi xflags,$02
        mov wdt1000,load1000  ; wdtpor
        mov wdt100,load100
        mov wdt10,load10
        mov wdt1,load1
        sbi portb,rele
        reti

konec4:
	cpi wdt1,$02
	brne konec5
	sbis pinb,rxd
	ldi wdt1,$01
konec5:
	reti
	
cekej_na_start:
        sbis pinb,rxd
        rjmp rxd0
        sbrc xflags,xdin
        rjmp wdtdelic
        sbr xflags,xkdin
        ldi delic3,$01
        ldi xcitacbitu,$00
        sbr xflags,xkprijimej
        rjmp wdtdelic

rxd0:
        cbr xflags,xkdin  ; vstup je 0
	mov mko_rx,hod_ok_rx
        rjmp wdtdelic

jest_stopbit:
	mov mko_rx,hod_ok_rx
        cpi rxdata,$30
        brmi neni_wdt    ; mensi nez 0
	andi xflags,$f6  ; nuluj xprijimej a xdata
        cpi rxdata,$3a
        brmi vypocet     ; 0 ... 9
        cpi rxdata,$73   ; s
        breq je_s
        cpi rxdata,$74   ; t
        breq je_t
        cpi rxdata,$64   ; d
        breq je_d
        cpi rxdata,$77   ; w
        breq je_w
	rjmp ostatni

vypocet:
        sbrs xflags,x_t
        rjmp neni_wdt
        andi rxdata,$0f
        mov val1000,val100
        mov val100,val10
        inc rxdata
        mov val10,val1
        mov val1,rxdata
        rjmp wdtdelic

je_s:
        sbrs xflags,x_t
        rjmp neni_wdt
	out ddrb,sviti
	sbrc xpor,por_r
	rjmp nastav_wdtpor
        mov wdt1000,val1000
        mov wdt100,val100
        mov wdt10,val10
        mov wdt1,val1
	ldi delic125y,$7d
neni_startbit:
neni_wdt:
	andi xflags,$86
        ori  xflags,$02
        rjmp wdtdelic

je_t:
	sbrc xflags,x_t
	andi xflags,$86
        sbrc xflags,x_d
        sbr  xflags,xk_t
	ldi xpor,$00
        ldi val1000,$01
        ldi val100,$01
        ldi val10,$01
        ldi val1,$01
        rjmp wdtdelic

je_d:
	sbrc xflags,x_d
	andi xflags,$86
        sbrc xflags,x_w
        sbr  xflags,xk_d
	ldi xpor,$00
        rjmp wdtdelic

je_w:
	andi xflags,$96  ; nuluj x_t a x_d
        sbr  xflags,xk_w
	ldi xpor,$00
        rjmp wdtdelic

; ------------------------------------

pokracuj:
        ; nastavi wdt na chipu
	ldi xcitacbitu,$00
	wdr
	ldi pom,$08
	out wdtcr,pom       ; povoli watchdog
	ldi pom,$01
	wdr
	mov hod1,pom
	out tccr0,hod1      ; nastavi delicku pro casovac
	mov hod0,xcitacbitu
	out tcnt0,hod0
	out tifr,hod0
        ldi pom,$04
	out portb,pom
        out ddrb,pom
	mov zhasne,pom
	out portb,pom
	ldi pom,$24
	mov sviti,pom
	out eear,hod1
	out eecr,hod1
	ldi xflags,$02
	ldi xpor,$00
	in wdt100,eedr
	out eear,hod0
	out eecr,hod1
	mov  wdt1000,wdt100
	andi wdt100,$0f
	breq nastav900
	swap wdt1000
	andi wdt1000,$0f
	breq nastav900
	cpi  wdt1000,$0b
	brpl nastav900
	cpi  wdt100,$0b
	brpl nastav900
	in wdt1,eedr
	mov  wdt10,wdt1
	andi wdt1,$0f
	breq nastav900
	swap wdt10
	andi wdt10,$0f
	breq nastav900
	cpi  wdt10,$0b
	brpl nastav900
	cpi  wdt1,$0b
	brmi dobrewdt
nastav900:
        ldi wdt1000,$01  ; 15 minut = 900 sekund
        ldi wdt100,$0a
        ldi wdt10,$01
        ldi wdt1,$01
dobrewdt:
	out eear,xflags
	out eecr,hod1
	mov load1,wdt1  ; ulozit pro pouziti
	mov load10,wdt10
	mov load100,wdt100
	mov load1000,wdt1000
	in stav,eedr ; na eeadr=2 je ulozen rezim hlidani
	and stav,hod1
	cpi val1000,$2D
	brne err_poweroff
	cpi val100,$4B
	brne err_poweroff
	cpi val10,$57
	brmi ok_poweroff
err_poweroff:
	ldi val1,$10
	ldi val10,$03
	cp stav,hod1
	breq hlidacir
	ldi val10,$01
hlidacir:
	ldi val100,$4B
	ldi val1000,$2D
	rjmp spol_power

ok_poweroff:
        cp stav,hod1
	breq spol_power
	cpi val10,$02
	brmi spol_power
	dec val10
spol_power:
	cp load_off1,xflags
	brmi err_nastaveni
	ldi pom,$3e
	cp citac_off1,pom
	brmi ok_nastaveni
	cp load_off1,pom
	brmi ok_nastaveni
err_nastaveni:
	ldi pom,$03
	mov load_off1,pom
	mov citac_off1,load_off1
ok_nastaveni:
	sbic pinb,rxd
	rjmp pc_odpojeno
pc_pripojeno:
	ldi pom,$7d
	mov delic125x,pom
	mov delic125y,pom
	ldi pom,$03
	mov load_off1,pom
	mov citac_off1,pom
	ldi pom,ok_rx
	mov hod_ok_rx,pom
	mov mko_rx,pom
	clr tlmko
	clr tlcitac
	out timsk,xflags    ; povoli interrupt od casovace
	sei
nasebe:
	rjmp nasebe
	rjmp nasebe
	rjmp nasebe

pc_odpojeno:
	sbis pinb,rxd
	rjmp pc_pripojeno
	sbic pinb,tlacitko
	rjmp tl_nestisk1
	cpi status_tlacitka,$ff
	breq tl_nestisk1
	rjmp tlacitko_stisknuto

tl_nestisk1:
	sbis pinb,rxd
	rjmp pc_pripojeno
	inc citac_resetu
	cp stav,hod1
	brne wdt2s
	; stav = 1 --> pravidelne zapina PC, pokud PC nebezi
	cp citac_resetu,hod1
	breq wdt2sq
	brpl sviti_led
	clr citac_resetu
wdt2sq:
	dec citac_off1
	brne wdt2s
	mov citac_off1,load_off1
	lsl load_off1
	ldi pom,$3c
	cp load_off1,pom
	brmi sepni_rele
	mov load_off1,pom
	rjmp sepni_rele

wdt2s:
	ldi pom,$0f
wdtxs:
	sbic pinb,tlacitko
	rjmp tl_nestisk2
	cpi status_tlacitka,$ff
	breq wdtxs12
	rjmp tlacitko_stisknuto

tl_nestisk2:
	clr status_tlacitka
wdtxs12:
	cpi val10,$00
	breq vynech_out0
	dec val1
	brne jdi_wdtxs12
	dec val10
jdi_wdtxs12:
	cbi portb,tlacitko
	sbi ddrb,tlacitko
vynech_out0:
	out wdtcr,pom
	wdr
	ldi pom,$30
	out mcucr,pom
	sleep
	rjmp pokracuj

sviti_led:
	clr citac_resetu
	dec citac_resetu
	out ddrb,sviti
	ldi pom,$0b
	rjmp wdtxs
	
tlacitko_stisknuto:
sepni_rele:
	cbi portb,rele ; rele ON
	ldi citac3,$25
	clr citac2
	clr citac1
	cpi val10,$00
	brne nex1
	inc val10
	ldi val1,$08
nex1:
	rjmp nex2
nex2:
	cbi portb,tlacitko
	sbi ddrb,tlacitko
cekej1:
	nop
	dec citac1
	brne cekej1
	wdr
	dec citac2
	brne cekej1
	dec citac3
	breq stale_odpojeno
	sbic pinb,rxd
	rjmp cekej1
stale_odpojeno:
	ldi status_tlacitka,$ff
	ldi pom,$0f
	rjmp jdi_wdtxs12
